<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
<meta name="generator" content="pdoc 0.5.3" />
<title>server API documentation</title>
<meta name="description" content="" />
<link href='https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.0/normalize.min.css' rel='stylesheet'>
<link href='https://cdnjs.cloudflare.com/ajax/libs/10up-sanitize.css/8.0.0/sanitize.min.css' rel='stylesheet'>
<link href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" rel="stylesheet">
<style>.flex{display:flex !important}body{line-height:1.5em}#content{padding:20px}#sidebar{padding:30px;overflow:hidden}.http-server-breadcrumbs{font-size:130%;margin:0 0 15px 0}#footer{font-size:.75em;padding:5px 30px;border-top:1px solid #ddd;text-align:right}#footer p{margin:0 0 0 1em;display:inline-block}#footer p:last-child{margin-right:30px}h1,h2,h3,h4,h5{font-weight:300}h1{font-size:2.5em;line-height:1.1em}h2{font-size:1.75em;margin:1em 0 .50em 0}h3{font-size:1.4em;margin:25px 0 10px 0}h4{margin:0;font-size:105%}a{color:#058;text-decoration:none;transition:color .3s ease-in-out}a:hover{color:#e82}.title code{font-weight:bold}h2[id^="header-"]{margin-top:2em}.ident{color:#900}pre code{background:#f8f8f8;font-size:.8em;line-height:1.4em}code{background:#f2f2f1;padding:1px 4px;overflow-wrap:break-word}h1 code{background:transparent}pre{background:#f8f8f8;border:0;border-top:1px solid #ccc;border-bottom:1px solid #ccc;margin:1em 0;padding:1ex}#http-server-module-list{display:flex;flex-flow:column}#http-server-module-list div{display:flex}#http-server-module-list dt{min-width:10%}#http-server-module-list p{margin-top:0}.toc ul,#index{list-style-type:none;margin:0;padding:0}#index code{background:transparent}#index h3{border-bottom:1px solid #ddd}#index ul{padding:0}#index h4{font-weight:bold}#index h4 + ul{margin-bottom:.6em}@media (min-width:200ex){#index .two-column{column-count:2}}@media (min-width:300ex){#index .two-column{column-count:3}}dl{margin-bottom:2em}dl dl:last-child{margin-bottom:4em}dd{margin:0 0 1em 3em}#header-classes + dl > dd{margin-bottom:3em}dd dd{margin-left:2em}dd p{margin:10px 0}.name{background:#eee;font-weight:bold;font-size:.85em;padding:5px 10px;display:inline-block;min-width:40%}.name:hover{background:#e0e0e0}.name > span:first-child{white-space:nowrap}.name.class > span:nth-child(2){margin-left:.4em}.name small{font-weight:normal}.inherited{color:#999;border-left:5px solid #eee;padding-left:1em}.inheritance em{font-style:normal;font-weight:bold}.desc h2{font-weight:400;font-size:1.25em}.desc h3{font-size:1em}.desc dt code{background:inherit}.source summary{color:#666;text-align:right;font-weight:400;font-size:.8em;text-transform:uppercase;cursor:pointer}.source pre{max-height:500px;overflow:auto;margin:0}.source pre code{font-size:12px;overflow:visible}.hlist{list-style:none}.hlist li{display:inline}.hlist li:after{content:',\2002'}.hlist li:last-child:after{content:none}.hlist .hlist{display:inline;padding-left:1em}img{max-width:100%}.admonition{padding:.1em .5em}.admonition-title{font-weight:bold}.admonition.note,.admonition.info,.admonition.important{background:#aef}.admonition.todo,.admonition.versionadded,.admonition.tip,.admonition.hint{background:#dfd}.admonition.warning,.admonition.versionchanged,.admonition.deprecated{background:#fd4}.admonition.error,.admonition.danger,.admonition.caution{background:lightpink}</style>
<style media="screen and (min-width: 700px)">@media screen and (min-width:700px){#sidebar{width:30%}#content{width:70%;max-width:100ch;padding:3em 4em;border-left:1px solid #ddd}pre code{font-size:1em}.item .name{font-size:1em}main{display:flex;flex-direction:row-reverse;justify-content:flex-end}.toc ul ul,#index ul{padding-left:1.5em}.toc > ul > li{margin-top:.5em}}</style>
<style media="print">@media print{#sidebar h1{page-break-before:always}.source{display:none}}@media print{*{background:transparent !important;color:#000 !important;box-shadow:none !important;text-shadow:none !important}a[href]:after{content:" (" attr(href) ")";font-size:90%}a[href][title]:after{content:none}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}pre,blockquote{border:1px solid #999;page-break-inside:avoid}thead{display:table-header-group}tr,img{page-break-inside:avoid}img{max-width:100% !important}@page{margin:0.5cm}p,h2,h3{orphans:3;widows:3}h1,h2,h3,h4,h5,h6{page-break-after:avoid}}</style>
</head>
<body>
<main>
<article id="content">
<header>
<h1 class="title"><code>server</code> module</h1>
</header>
<section id="section-intro">
<details class="source">
<summary>Source code</summary>
<pre><code class="python">from flask import Flask, request, render_template, Response
from collections import defaultdict
import requests
import json
from sklearn.decomposition import LatentDirichletAllocation
from sklearn.externals import joblib
from sklearn.feature_extraction.text import CountVectorizer
import pandas as pd
import numpy as np
from elasticsearch import Elasticsearch

&#34;&#34;&#34;
Code for the REST API of the project. 

The server will provide at least the following endpoints: 
    /mlt/classic/&lt;id&gt; : returns the documents considered similar by original MLT to the document with specified id
    /mlt/modified/&lt;id&gt; : returns the documents considered similar by the topic based similarity measure to the document with specified id
    /mlt/speedy/&lt;id&gt; : like modified, but with filtering hopeless candidates
    /mlt/add : a route that let&#39;s user post a document, calculates the topic distribution and indexes this document
    /mlt/compare/&lt;id&gt; : renders a view showing results of the classic and modified approaches
&#34;&#34;&#34;


app = Flask(__name__)
N_TOPICS = 25
ES_HOST = &#34;localhost&#34;
ES_PORT = 9200
ES_URL = &#34;http://&#34; + ES_HOST + &#34;:&#34; + str(ES_PORT)
INDEX_NAME = &#34;topic_docs&#34;
ES_DOC_TYPE = &#34;article&#34;

# preload topic model, for indexing new documents
mlda = joblib.load(&#34;mylda.pkl&#34;)
vocab = joblib.load(&#34;vocabulary.pkl&#34;)
tf_vectorizer = CountVectorizer(max_df=0.95, min_df=2, vocabulary=vocab, stop_words=&#34;english&#34;)




@app.route(&#34;/mlt/classic/&lt;id&gt;&#34;)
def classic(id, index_url=&#34;/&#34;.join([ES_URL, INDEX_NAME, &#34;_search&#34;]), ):
    &#34;&#34;&#34;Return documents considered similar by original MLT.
    
    This is a wrapper around the original More Like This query provided
    by elastic search. After building a query in json format for the specified
    id, the query gets send to the ES server and the resulting is returned as
    a string.  

    Keyword Arguments:  
    `id` : the elastic search id of the document of interest
    &#34;&#34;&#34;
    query = build_query(id=id)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    print(query)
    r = requests.get(index_url, data=query, headers=head)
    # post process the result
    similar_docs = json.loads(r.text)
    for d in similar_docs[&#34;hits&#34;][&#34;hits&#34;]:
        print(d[&#34;_id&#34;], &#34; : &#34;, d[&#34;_source&#34;][&#34;title&#34;]) 
    return r.text


@app.route(&#34;/mlt/modified/&lt;id&gt;&#34;)
def modified(id, es_url=ES_URL, index=INDEX_NAME, _type=ES_DOC_TYPE):
    &#34;&#34;&#34; Return documents with a similar topic distribution to the document of interest.  
    
    After getting the topic distribution of the queried document, a scripted query is built
    and sent to the elastic search server.  

    Keyword Arguments:  
    `id` : the elastic search id of the document of interest
    &#34;&#34;&#34;
    t_dist = get_topic_dist(es_url, index, _type, id)
    # build and send query to get documents with similar topic distributions
    query = build_modified_query(t_dist)
    print(query)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    r = requests.post(&#34;/&#34;.join([es_url, index, _type, &#34;_search&#34;]), data=query, headers=head) 
    # post process the result
    similar_docs = json.loads(r.text)
    print(similar_docs)
    for d in similar_docs[&#34;hits&#34;][&#34;hits&#34;]:
        print(d[&#34;_id&#34;], &#34; : &#34;, d[&#34;_source&#34;][&#34;title&#34;]) 
    return r.text


@app.route(&#34;/mlt/speedy/&lt;id&gt;&#34;)
def speedy(id, es_url=ES_URL, index=INDEX_NAME, _type=ES_DOC_TYPE, thresh=0.05):
    &#34;&#34;&#34;Return documents with a topic distribution similar to the one of document with id `id`,
    but use prefiltering to speed up the process.
    
    After getting the topic distribution of the document of interest, this information is used
    to build a `speedy_query` - a query which discards all documents with a topic distribution
    where this topic does not have an influence larger than the given threshold.
    All documents containing the most significant topic to an amount larger than `thresh` are
    returned, ordered by their similarity to the document with id `id`.

    Keyword Arguments:  
    `id`: the id of the queried document  
    `es_url`: the url of the elastic search server  
    `index`: the name of the elastic search index  
    `type`: the name of the elastic search type  
    `thresh`: threshold - all documents containing less than the specified amount of the most  
    significant topic of the queried document will be disregarded without further checking for  
    similarity
    &#34;&#34;&#34;
    t_dist = get_topic_dist(es_url, index, _type, id)
    query = build_speedy_query(t_dist=t_dist, thresh=thresh)
    print(query)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    r = requests.post(&#34;/&#34;.join([es_url, index, _type, &#34;_search&#34;]), data=query, headers=head) 
    # post process the result
    similar_docs = json.loads(r.text)
    print(similar_docs)
    # backup plan: carry out modified query without prefiltering
    if len(similar_docs[&#34;hits&#34;][&#34;hits&#34;]) &lt; 5:
        print(&#34;Sped up query did not return enough documents. Using modified query...&#34;)
        return modified(id=id)
    for d in similar_docs[&#34;hits&#34;][&#34;hits&#34;]:
        print(d[&#34;_id&#34;], &#34; : &#34;, d[&#34;_source&#34;][&#34;title&#34;]) 
    return r.text


@app.route(&#34;/mlt/compare/&lt;id&gt;&#34;)
def compare(id, es_url=ES_URL, index=INDEX_NAME, _type=ES_DOC_TYPE):
    &#34;&#34;&#34;Render a view that compares the results of the original/modified queries in tabular form.  
    
    This route provides a comparison of the results of the standard/modified MLT queries in
    tabular form. A standard MLT query and a modified query for the document with the
    given `id` are sent to the elastic search server. The 5 best matching documents according to each query
    are presented.
    &#34;&#34;&#34;
    orig, mod = classic(id), modified(id)
    orig_sim = json.loads(orig)
    orig_list = list()
    for d in orig_sim[&#34;hits&#34;][&#34;hits&#34;]:
        orig_list.append((d[&#34;_id&#34;], d[&#34;_source&#34;][&#34;title&#34;], d[&#34;_source&#34;][&#34;text&#34;]))   
    # by default only max. 50 characters are returned per cell; make it return more
    pd.set_option(&#39;display.max_colwidth&#39;, 1000)
    orig_table = pd.DataFrame.from_records(orig_list[:5], 
                              columns=[&#34;id&#34;, &#34;title&#34;, &#34;text&#34;]).to_html(index=False)
    print(&#34;Orig table created&#34;)
    mod_sim = json.loads(mod)
    mod_list = list()
    # the first result will be the document itself, filter this out
    for d in mod_sim[&#34;hits&#34;][&#34;hits&#34;][1:]:
        mod_list.append((d[&#34;_id&#34;], d[&#34;_source&#34;][&#34;title&#34;], d[&#34;_source&#34;][&#34;text&#34;]))
    mod_table = pd.DataFrame.from_records(mod_list[:5], 
                             columns=[&#34;id&#34;, &#34;title&#34;, &#34;text&#34;]).to_html(index=False)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    r = requests.get(&#34;/&#34;.join([es_url, index, _type, id]), headers=head)
    doc_title = json.loads(r.text)[&#34;_source&#34;][&#34;title&#34;] 
    return render_template(&#34;compare_view.html&#34;,tables=[orig_table, mod_table], 
                        query_doc=doc_title, 
                        titles=[&#34;y1based&#34;, &#34;Original Similar Articles&#34;, &#34;Modified Similar Articles&#34;])


@app.route(&#34;/mlt/add&#34;, methods=[&#34;POST&#34;])
def index_document():
    &#34;&#34;&#34;Index a new document.
    
    This route can be used to post a document that will be enriched with topic information and then
    indexed in elastic search. It expects a valid `json` with at least a field `text` which 
    contains the text used to compute the topic distribution. 
    &#34;&#34;&#34;
    article = request.json
    if &#34;text&#34; not in article.keys():
        return &#34;A &#39;text&#39; field is needed!&#34;, 400
    content = annotate_document(article)
    es = Elasticsearch(hosts=[{&#34;host&#34;: ES_HOST, &#34;port&#34;: ES_PORT}])
    res = es.index(index=INDEX_NAME, doc_type=ES_DOC_TYPE, body=content)
    indexed_id = res[&#34;_id&#34;]
    return(indexed_id)


def annotate_document(doc):
    &#34;&#34;&#34;Calculate the topic distribution of a document and add
    this information to the provided json.  

    The pretrained topic model saved in `mlda` is used to compute the topic distribution of the provided
    document. This information is added to the json and the modified json document is returned.  

    Keyword Arguments:  
    `doc`: the json document to annotate with topic information. It needs to have at least 
    a field `text`, which contains the text of which the topic distribution is calculated.

    &#34;&#34;&#34;
    content = doc
    text = tf_vectorizer.fit_transform(list(content[&#34;text&#34;]))
    t_dist = mlda.transform(text[0])
    for dist_key, dist_v in enumerate(t_dist.flatten()):
        content[&#34;topic_{}&#34;.format(dist_key)] = dist_v
    return content 


def build_modified_query(dist):
    &#34;&#34;&#34;Return a query that can be sent to elastic search to get back documents with a
    similar topic distribution to the one provided.  

    This builds a scripted query. The query calculates the inverse of the 
    Kullback Leibler Divergence of the specified topic distribution with the topic distributions
    of all other documents in the elastic search index. 
    The Kullback Leibler Divergence measures, how different one probability distribution is to
    another, so the inverse can be used to find similar documents.

    Keyword Arguments:  
    `dist`: the topic distribution
    &#34;&#34;&#34;
    params = {&#34;topic_{}&#34;.format(i) : val for i, val in enumerate(dist)}
    sources = [&#34;params.topic_{} * Math.log(params.topic_{} / doc[&#39;topic_{}&#39;].value)&#34;.format(i,i,i)
                for i in range(len(dist))]
    script_formula = &#34;return 1/(&#34; + &#39;+&#39;.join(sources) + &#34; + 0.1);&#34;
    query = defaultdict(lambda: defaultdict(dict))
    query[&#34;function_score&#34;][&#34;query&#34;] = dict()
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;match_all&#34;] = {}
    query[&#34;function_score&#34;][&#34;script_score&#34;] = defaultdict(lambda:defaultdict(dict))
    for pkey in params.keys():
        query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;params&#34;][pkey] = params[pkey]
    query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;source&#34;] = script_formula
    query[&#34;function_score&#34;][&#34;boost_mode&#34;] = &#34;replace&#34;
    query = {&#34;query&#34; : query}
    return(json.dumps(query))


def build_speedy_query(t_dist, thresh=0.05):
    &#34;&#34;&#34;
    Return a modified query that first filters out all documents with a small part of the most
    significant topic.  

    This builds a function score query which calculates the inverse of the KL-divergence for 
    a subset of documents in the elastic search index. This is done by applying a range 
    query before the actual scripted query is applied. The range query filters out all 
    documents in which the most significant topic in `t_dist` does not have an impact above
    the amount specified by `thresh`.

    Keyword Arguments:  
    `t_dist`: topic distribution for which similar documents are queried
    `thresh`: documents containing an amount less than `thresh` of the most significant 
    topic in `t_dist` are disgarded, before the scripted score is calculated for them.
    This is done in order to improve the execution speed of the query.
    &#34;&#34;&#34;
    max_topic = np.argmax(t_dist)
    params = {&#34;topic_{}&#34;.format(i) : val for i, val in enumerate(t_dist)}
    sources = [&#34;params.topic_{} * Math.log(params.topic_{} / doc[&#39;topic_{}&#39;].value)&#34;.format(i,i,i)
                for i in range(len(t_dist))]
    script_formula = &#34;return 1/(&#34; + &#39;+&#39;.join(sources) + &#34; + 0.1);&#34;
    query = defaultdict(lambda: defaultdict(dict))
    query[&#34;function_score&#34;][&#34;query&#34;] = dict()

    # range query to filter out docs with low contribution of max_topic
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;range&#34;] = dict()
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;range&#34;][&#34;topic_{}&#34;.format(max_topic)] = dict()
    # filter out everything with lower contribution than thresh
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;range&#34;][&#34;topic_{}&#34;.format(max_topic)][&#34;gte&#34;] = thresh

    # the actual script
    query[&#34;function_score&#34;][&#34;script_score&#34;] = defaultdict(lambda:defaultdict(dict))
    for pkey in params.keys():
        query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;params&#34;][pkey] = params[pkey]
    query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;source&#34;] = script_formula
    query[&#34;function_score&#34;][&#34;boost_mode&#34;] = &#34;replace&#34;
    query = {&#34;query&#34; : query}
    return(json.dumps(query))


def build_query(field=&#34;text&#34;, index=&#34;topic_docs&#34;, _type=&#34;article&#34;, 
                        id=42, min_term_freq=2, max_query_terms=25):
    &#34;&#34;&#34;Return a json containing a standard MLT query for a specified document.

    Keyword arguments:  
    `field`: field on which to perform the MLT query (default &#34;text&#34;)  
    `index`: elastic search index to query (default &#34;topic_docs&#34;)  
    `_type`: elastic search index type to query (default &#34;article&#34;)  
    `_id`:   elastic search id of the document to query (default 42)  
    `min_term_freq`: minimum term frequency below which the terms will be
                     ignored from the input document (default 2)  
    `max_query_terms`: maximum number of query terms that will be selected (default 25)  
    &#34;&#34;&#34;
    qdict = defaultdict(lambda: defaultdict(dict))
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;fields&#34;] = [field]
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;like&#34;] = [{&#34;_index&#34; : index, 
                                                 &#34;_type&#34; : _type, &#34;_id&#34; : str(id)}]
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;min_term_freq&#34;] = min_term_freq
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;max_query_terms&#34;] = max_query_terms
    return json.dumps(qdict)


def get_topic_dist(es_url, index, _type, id):
    &#34;&#34;&#34;Return the topic distribution of a given document.  

    This sends a request to the elastic search server, asking for the document with the
    specified `id` and extracts the topic distribution of the document.  

    Keyword Arguments:  
    `id`: the elastic search id of the queried document
    &#34;&#34;&#34;
    # get the document by id
    doc = requests.get(&#34;/&#34;.join([es_url, index, _type, id]))
    doc = json.loads(doc.text)
    # read the topic distribution
    t_dist = list()
    for i in range(N_TOPICS):
        t_dist.append(doc[&#34;_source&#34;][&#34;topic_{}&#34;.format(i)])
    return t_dist</code></pre>
</details>
</section>
<section>
</section>
<section>
</section>
<section>
<h2 class="section-title" id="header-functions">Functions</h2>
<dl>
<dt id="server.annotate_document"><code class="name flex">
<span>def <span class="ident">annotate_document</span></span>(<span>doc)</span>
</code></dt>
<dd>
<section class="desc"><p>Calculate the topic distribution of a document and add
this information to the provided json.
</p>
<p>The pretrained topic model saved in <code>mlda</code> is used to compute the topic distribution of the provided
document. This information is added to the json and the modified json document is returned.
</p>
<p>Keyword Arguments:<br>
<code>doc</code>: the json document to annotate with topic information. It needs to have at least
a field <code>text</code>, which contains the text of which the topic distribution is calculated.</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def annotate_document(doc):
    &#34;&#34;&#34;Calculate the topic distribution of a document and add
    this information to the provided json.  

    The pretrained topic model saved in `mlda` is used to compute the topic distribution of the provided
    document. This information is added to the json and the modified json document is returned.  

    Keyword Arguments:  
    `doc`: the json document to annotate with topic information. It needs to have at least 
    a field `text`, which contains the text of which the topic distribution is calculated.

    &#34;&#34;&#34;
    content = doc
    text = tf_vectorizer.fit_transform(list(content[&#34;text&#34;]))
    t_dist = mlda.transform(text[0])
    for dist_key, dist_v in enumerate(t_dist.flatten()):
        content[&#34;topic_{}&#34;.format(dist_key)] = dist_v
    return content </code></pre>
</details>
</dd>
<dt id="server.build_modified_query"><code class="name flex">
<span>def <span class="ident">build_modified_query</span></span>(<span>dist)</span>
</code></dt>
<dd>
<section class="desc"><p>Return a query that can be sent to elastic search to get back documents with a
similar topic distribution to the one provided.
</p>
<p>This builds a scripted query. The query calculates the inverse of the
Kullback Leibler Divergence of the specified topic distribution with the topic distributions
of all other documents in the elastic search index.
The Kullback Leibler Divergence measures, how different one probability distribution is to
another, so the inverse can be used to find similar documents.</p>
<p>Keyword Arguments:<br>
<code>dist</code>: the topic distribution</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def build_modified_query(dist):
    &#34;&#34;&#34;Return a query that can be sent to elastic search to get back documents with a
    similar topic distribution to the one provided.  

    This builds a scripted query. The query calculates the inverse of the 
    Kullback Leibler Divergence of the specified topic distribution with the topic distributions
    of all other documents in the elastic search index. 
    The Kullback Leibler Divergence measures, how different one probability distribution is to
    another, so the inverse can be used to find similar documents.

    Keyword Arguments:  
    `dist`: the topic distribution
    &#34;&#34;&#34;
    params = {&#34;topic_{}&#34;.format(i) : val for i, val in enumerate(dist)}
    sources = [&#34;params.topic_{} * Math.log(params.topic_{} / doc[&#39;topic_{}&#39;].value)&#34;.format(i,i,i)
                for i in range(len(dist))]
    script_formula = &#34;return 1/(&#34; + &#39;+&#39;.join(sources) + &#34; + 0.1);&#34;
    query = defaultdict(lambda: defaultdict(dict))
    query[&#34;function_score&#34;][&#34;query&#34;] = dict()
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;match_all&#34;] = {}
    query[&#34;function_score&#34;][&#34;script_score&#34;] = defaultdict(lambda:defaultdict(dict))
    for pkey in params.keys():
        query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;params&#34;][pkey] = params[pkey]
    query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;source&#34;] = script_formula
    query[&#34;function_score&#34;][&#34;boost_mode&#34;] = &#34;replace&#34;
    query = {&#34;query&#34; : query}
    return(json.dumps(query))</code></pre>
</details>
</dd>
<dt id="server.build_query"><code class="name flex">
<span>def <span class="ident">build_query</span></span>(<span>field=&#39;text&#39;, index=&#39;topic_docs&#39;, _type=&#39;article&#39;, id=42, min_term_freq=2, max_query_terms=25)</span>
</code></dt>
<dd>
<section class="desc"><p>Return a json containing a standard MLT query for a specified document.</p>
<p>Keyword arguments:<br>
<code>field</code>: field on which to perform the MLT query (default "text")<br>
<code>index</code>: elastic search index to query (default "topic_docs")<br>
<code>_type</code>: elastic search index type to query (default "article")<br>
<code>_id</code>:
elastic search id of the document to query (default 42)<br>
<code>min_term_freq</code>: minimum term frequency below which the terms will be
ignored from the input document (default 2)<br>
<code>max_query_terms</code>: maximum number of query terms that will be selected (default 25)</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def build_query(field=&#34;text&#34;, index=&#34;topic_docs&#34;, _type=&#34;article&#34;, 
                        id=42, min_term_freq=2, max_query_terms=25):
    &#34;&#34;&#34;Return a json containing a standard MLT query for a specified document.

    Keyword arguments:  
    `field`: field on which to perform the MLT query (default &#34;text&#34;)  
    `index`: elastic search index to query (default &#34;topic_docs&#34;)  
    `_type`: elastic search index type to query (default &#34;article&#34;)  
    `_id`:   elastic search id of the document to query (default 42)  
    `min_term_freq`: minimum term frequency below which the terms will be
                     ignored from the input document (default 2)  
    `max_query_terms`: maximum number of query terms that will be selected (default 25)  
    &#34;&#34;&#34;
    qdict = defaultdict(lambda: defaultdict(dict))
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;fields&#34;] = [field]
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;like&#34;] = [{&#34;_index&#34; : index, 
                                                 &#34;_type&#34; : _type, &#34;_id&#34; : str(id)}]
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;min_term_freq&#34;] = min_term_freq
    qdict[&#34;query&#34;][&#34;more_like_this&#34;][&#34;max_query_terms&#34;] = max_query_terms
    return json.dumps(qdict)</code></pre>
</details>
</dd>
<dt id="server.build_speedy_query"><code class="name flex">
<span>def <span class="ident">build_speedy_query</span></span>(<span>t_dist, thresh=0.05)</span>
</code></dt>
<dd>
<section class="desc"><p>Return a modified query that first filters out all documents with a small part of the most
significant topic.
</p>
<p>This builds a function score query which calculates the inverse of the KL-divergence for
a subset of documents in the elastic search index. This is done by applying a range
query before the actual scripted query is applied. The range query filters out all
documents in which the most significant topic in <code>t_dist</code> does not have an impact above
the amount specified by <code>thresh</code>.</p>
<p>Keyword Arguments:<br>
<code>t_dist</code>: topic distribution for which similar documents are queried
<code>thresh</code>: documents containing an amount less than <code>thresh</code> of the most significant
topic in <code>t_dist</code> are disgarded, before the scripted score is calculated for them.
This is done in order to improve the execution speed of the query.</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def build_speedy_query(t_dist, thresh=0.05):
    &#34;&#34;&#34;
    Return a modified query that first filters out all documents with a small part of the most
    significant topic.  

    This builds a function score query which calculates the inverse of the KL-divergence for 
    a subset of documents in the elastic search index. This is done by applying a range 
    query before the actual scripted query is applied. The range query filters out all 
    documents in which the most significant topic in `t_dist` does not have an impact above
    the amount specified by `thresh`.

    Keyword Arguments:  
    `t_dist`: topic distribution for which similar documents are queried
    `thresh`: documents containing an amount less than `thresh` of the most significant 
    topic in `t_dist` are disgarded, before the scripted score is calculated for them.
    This is done in order to improve the execution speed of the query.
    &#34;&#34;&#34;
    max_topic = np.argmax(t_dist)
    params = {&#34;topic_{}&#34;.format(i) : val for i, val in enumerate(t_dist)}
    sources = [&#34;params.topic_{} * Math.log(params.topic_{} / doc[&#39;topic_{}&#39;].value)&#34;.format(i,i,i)
                for i in range(len(t_dist))]
    script_formula = &#34;return 1/(&#34; + &#39;+&#39;.join(sources) + &#34; + 0.1);&#34;
    query = defaultdict(lambda: defaultdict(dict))
    query[&#34;function_score&#34;][&#34;query&#34;] = dict()

    # range query to filter out docs with low contribution of max_topic
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;range&#34;] = dict()
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;range&#34;][&#34;topic_{}&#34;.format(max_topic)] = dict()
    # filter out everything with lower contribution than thresh
    query[&#34;function_score&#34;][&#34;query&#34;][&#34;range&#34;][&#34;topic_{}&#34;.format(max_topic)][&#34;gte&#34;] = thresh

    # the actual script
    query[&#34;function_score&#34;][&#34;script_score&#34;] = defaultdict(lambda:defaultdict(dict))
    for pkey in params.keys():
        query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;params&#34;][pkey] = params[pkey]
    query[&#34;function_score&#34;][&#34;script_score&#34;][&#34;script&#34;][&#34;source&#34;] = script_formula
    query[&#34;function_score&#34;][&#34;boost_mode&#34;] = &#34;replace&#34;
    query = {&#34;query&#34; : query}
    return(json.dumps(query))</code></pre>
</details>
</dd>
<dt id="server.classic"><code class="name flex">
<span>def <span class="ident">classic</span></span>(<span>id, index_url=&#39;http://localhost:9200/topic_docs/_search&#39;)</span>
</code></dt>
<dd>
<section class="desc"><p>Return documents considered similar by original MLT.</p>
<p>This is a wrapper around the original More Like This query provided
by elastic search. After building a query in json format for the specified
id, the query gets send to the ES server and the resulting is returned as
a string.
</p>
<p>Keyword Arguments:<br>
<code>id</code> : the elastic search id of the document of interest</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">@app.route(&#34;/mlt/classic/&lt;id&gt;&#34;)
def classic(id, index_url=&#34;/&#34;.join([ES_URL, INDEX_NAME, &#34;_search&#34;]), ):
    &#34;&#34;&#34;Return documents considered similar by original MLT.
    
    This is a wrapper around the original More Like This query provided
    by elastic search. After building a query in json format for the specified
    id, the query gets send to the ES server and the resulting is returned as
    a string.  

    Keyword Arguments:  
    `id` : the elastic search id of the document of interest
    &#34;&#34;&#34;
    query = build_query(id=id)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    print(query)
    r = requests.get(index_url, data=query, headers=head)
    # post process the result
    similar_docs = json.loads(r.text)
    for d in similar_docs[&#34;hits&#34;][&#34;hits&#34;]:
        print(d[&#34;_id&#34;], &#34; : &#34;, d[&#34;_source&#34;][&#34;title&#34;]) 
    return r.text</code></pre>
</details>
</dd>
<dt id="server.compare"><code class="name flex">
<span>def <span class="ident">compare</span></span>(<span>id, es_url=&#39;http://localhost:9200&#39;, index=&#39;topic_docs&#39;)</span>
</code></dt>
<dd>
<section class="desc"><p>Render a view that compares the results of the original/modified queries in tabular form.
</p>
<p>This route provides a comparison of the results of the standard/modified MLT queries in
tabular form. A standard MLT query and a modified query for the document with the
given <code>id</code> are sent to the elastic search server. The 5 best matching documents according to each query
are presented.</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">@app.route(&#34;/mlt/compare/&lt;id&gt;&#34;)
def compare(id, es_url=ES_URL, index=INDEX_NAME, _type=ES_DOC_TYPE):
    &#34;&#34;&#34;Render a view that compares the results of the original/modified queries in tabular form.  
    
    This route provides a comparison of the results of the standard/modified MLT queries in
    tabular form. A standard MLT query and a modified query for the document with the
    given `id` are sent to the elastic search server. The 5 best matching documents according to each query
    are presented.
    &#34;&#34;&#34;
    orig, mod = classic(id), modified(id)
    orig_sim = json.loads(orig)
    orig_list = list()
    for d in orig_sim[&#34;hits&#34;][&#34;hits&#34;]:
        orig_list.append((d[&#34;_id&#34;], d[&#34;_source&#34;][&#34;title&#34;], d[&#34;_source&#34;][&#34;text&#34;]))   
    # by default only max. 50 characters are returned per cell; make it return more
    pd.set_option(&#39;display.max_colwidth&#39;, 1000)
    orig_table = pd.DataFrame.from_records(orig_list[:5], 
                              columns=[&#34;id&#34;, &#34;title&#34;, &#34;text&#34;]).to_html(index=False)
    print(&#34;Orig table created&#34;)
    mod_sim = json.loads(mod)
    mod_list = list()
    # the first result will be the document itself, filter this out
    for d in mod_sim[&#34;hits&#34;][&#34;hits&#34;][1:]:
        mod_list.append((d[&#34;_id&#34;], d[&#34;_source&#34;][&#34;title&#34;], d[&#34;_source&#34;][&#34;text&#34;]))
    mod_table = pd.DataFrame.from_records(mod_list[:5], 
                             columns=[&#34;id&#34;, &#34;title&#34;, &#34;text&#34;]).to_html(index=False)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    r = requests.get(&#34;/&#34;.join([es_url, index, _type, id]), headers=head)
    doc_title = json.loads(r.text)[&#34;_source&#34;][&#34;title&#34;] 
    return render_template(&#34;compare_view.html&#34;,tables=[orig_table, mod_table], 
                        query_doc=doc_title, 
                        titles=[&#34;y1based&#34;, &#34;Original Similar Articles&#34;, &#34;Modified Similar Articles&#34;])</code></pre>
</details>
</dd>
<dt id="server.get_topic_dist"><code class="name flex">
<span>def <span class="ident">get_topic_dist</span></span>(<span>es_url, index, _type, id)</span>
</code></dt>
<dd>
<section class="desc"><p>Return the topic distribution of a given document.
</p>
<p>This sends a request to the elastic search server, asking for the document with the
specified <code>id</code> and extracts the topic distribution of the document.
</p>
<p>Keyword Arguments:<br>
<code>id</code>: the elastic search id of the queried document</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">def get_topic_dist(es_url, index, _type, id):
    &#34;&#34;&#34;Return the topic distribution of a given document.  

    This sends a request to the elastic search server, asking for the document with the
    specified `id` and extracts the topic distribution of the document.  

    Keyword Arguments:  
    `id`: the elastic search id of the queried document
    &#34;&#34;&#34;
    # get the document by id
    doc = requests.get(&#34;/&#34;.join([es_url, index, _type, id]))
    doc = json.loads(doc.text)
    # read the topic distribution
    t_dist = list()
    for i in range(N_TOPICS):
        t_dist.append(doc[&#34;_source&#34;][&#34;topic_{}&#34;.format(i)])
    return t_dist</code></pre>
</details>
</dd>
<dt id="server.index_document"><code class="name flex">
<span>def <span class="ident">index_document</span></span>(<span>)</span>
</code></dt>
<dd>
<section class="desc"><p>Index a new document.</p>
<p>This route can be used to post a document that will be enriched with topic information and then
indexed in elastic search. It expects a valid <code>json</code> with at least a field <code>text</code> which
contains the text used to compute the topic distribution.</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">@app.route(&#34;/mlt/add&#34;, methods=[&#34;POST&#34;])
def index_document():
    &#34;&#34;&#34;Index a new document.
    
    This route can be used to post a document that will be enriched with topic information and then
    indexed in elastic search. It expects a valid `json` with at least a field `text` which 
    contains the text used to compute the topic distribution. 
    &#34;&#34;&#34;
    article = request.json
    if &#34;text&#34; not in article.keys():
        return &#34;A &#39;text&#39; field is needed!&#34;, 400
    content = annotate_document(article)
    es = Elasticsearch(hosts=[{&#34;host&#34;: ES_HOST, &#34;port&#34;: ES_PORT}])
    res = es.index(index=INDEX_NAME, doc_type=ES_DOC_TYPE, body=content)
    indexed_id = res[&#34;_id&#34;]
    return(indexed_id)</code></pre>
</details>
</dd>
<dt id="server.modified"><code class="name flex">
<span>def <span class="ident">modified</span></span>(<span>id, es_url=&#39;http://localhost:9200&#39;, index=&#39;topic_docs&#39;)</span>
</code></dt>
<dd>
<section class="desc"><p>Return documents with a similar topic distribution to the document of interest.
</p>
<p>After getting the topic distribution of the queried document, a scripted query is built
and sent to the elastic search server.
</p>
<p>Keyword Arguments:<br>
<code>id</code> : the elastic search id of the document of interest</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">@app.route(&#34;/mlt/modified/&lt;id&gt;&#34;)
def modified(id, es_url=ES_URL, index=INDEX_NAME, _type=ES_DOC_TYPE):
    &#34;&#34;&#34; Return documents with a similar topic distribution to the document of interest.  
    
    After getting the topic distribution of the queried document, a scripted query is built
    and sent to the elastic search server.  

    Keyword Arguments:  
    `id` : the elastic search id of the document of interest
    &#34;&#34;&#34;
    t_dist = get_topic_dist(es_url, index, _type, id)
    # build and send query to get documents with similar topic distributions
    query = build_modified_query(t_dist)
    print(query)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    r = requests.post(&#34;/&#34;.join([es_url, index, _type, &#34;_search&#34;]), data=query, headers=head) 
    # post process the result
    similar_docs = json.loads(r.text)
    print(similar_docs)
    for d in similar_docs[&#34;hits&#34;][&#34;hits&#34;]:
        print(d[&#34;_id&#34;], &#34; : &#34;, d[&#34;_source&#34;][&#34;title&#34;]) 
    return r.text</code></pre>
</details>
</dd>
<dt id="server.speedy"><code class="name flex">
<span>def <span class="ident">speedy</span></span>(<span>id, es_url=&#39;http://localhost:9200&#39;, index=&#39;topic_docs&#39;, thresh=0.05)</span>
</code></dt>
<dd>
<section class="desc"><p>Return documents with a topic distribution similar to the one of document with id <code>id</code>,
but use prefiltering to speed up the process.</p>
<p>After getting the topic distribution of the document of interest, this information is used
to build a <code>speedy_query</code> - a query which discards all documents with a topic distribution
where this topic does not have an influence larger than the given threshold.
All documents containing the most significant topic to an amount larger than <code>thresh</code> are
returned, ordered by their similarity to the document with id <code>id</code>.</p>
<p>Keyword Arguments:<br>
<code>id</code>: the id of the queried document<br>
<code>es_url</code>: the url of the elastic search server<br>
<code>index</code>: the name of the elastic search index<br>
<code>type</code>: the name of the elastic search type<br>
<code>thresh</code>: threshold - all documents containing less than the specified amount of the most<br>
significant topic of the queried document will be disregarded without further checking for<br>
similarity</p></section>
<details class="source">
<summary>Source code</summary>
<pre><code class="python">@app.route(&#34;/mlt/speedy/&lt;id&gt;&#34;)
def speedy(id, es_url=ES_URL, index=INDEX_NAME, _type=ES_DOC_TYPE, thresh=0.05):
    &#34;&#34;&#34;Return documents with a topic distribution similar to the one of document with id `id`,
    but use prefiltering to speed up the process.
    
    After getting the topic distribution of the document of interest, this information is used
    to build a `speedy_query` - a query which discards all documents with a topic distribution
    where this topic does not have an influence larger than the given threshold.
    All documents containing the most significant topic to an amount larger than `thresh` are
    returned, ordered by their similarity to the document with id `id`.

    Keyword Arguments:  
    `id`: the id of the queried document  
    `es_url`: the url of the elastic search server  
    `index`: the name of the elastic search index  
    `type`: the name of the elastic search type  
    `thresh`: threshold - all documents containing less than the specified amount of the most  
    significant topic of the queried document will be disregarded without further checking for  
    similarity
    &#34;&#34;&#34;
    t_dist = get_topic_dist(es_url, index, _type, id)
    query = build_speedy_query(t_dist=t_dist, thresh=thresh)
    print(query)
    head = {&#34;Content-type&#34;: &#34;application/json&#34;}
    r = requests.post(&#34;/&#34;.join([es_url, index, _type, &#34;_search&#34;]), data=query, headers=head) 
    # post process the result
    similar_docs = json.loads(r.text)
    print(similar_docs)
    # backup plan: carry out modified query without prefiltering
    if len(similar_docs[&#34;hits&#34;][&#34;hits&#34;]) &lt; 5:
        print(&#34;Sped up query did not return enough documents. Using modified query...&#34;)
        return modified(id=id)
    for d in similar_docs[&#34;hits&#34;][&#34;hits&#34;]:
        print(d[&#34;_id&#34;], &#34; : &#34;, d[&#34;_source&#34;][&#34;title&#34;]) 
    return r.text</code></pre>
</details>
</dd>
</dl>
</section>
<section>
</section>
</article>
<nav id="sidebar">
<h1>Index</h1>
<div class="toc">
<ul></ul>
</div>
<ul id="index">
<li><h3><a href="#header-functions">Functions</a></h3>
<ul class="">
<li><code><a title="server.annotate_document" href="#server.annotate_document">annotate_document</a></code></li>
<li><code><a title="server.build_modified_query" href="#server.build_modified_query">build_modified_query</a></code></li>
<li><code><a title="server.build_query" href="#server.build_query">build_query</a></code></li>
<li><code><a title="server.build_speedy_query" href="#server.build_speedy_query">build_speedy_query</a></code></li>
<li><code><a title="server.classic" href="#server.classic">classic</a></code></li>
<li><code><a title="server.compare" href="#server.compare">compare</a></code></li>
<li><code><a title="server.get_topic_dist" href="#server.get_topic_dist">get_topic_dist</a></code></li>
<li><code><a title="server.index_document" href="#server.index_document">index_document</a></code></li>
<li><code><a title="server.modified" href="#server.modified">modified</a></code></li>
<li><code><a title="server.speedy" href="#server.speedy">speedy</a></code></li>
</ul>
</li>
</ul>
</nav>
</main>
<footer id="footer">
<p>Generated by <a href="https://pdoc3.github.io/pdoc"><cite>pdoc</cite> 0.5.3</a>.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad()</script>
</body>
</html>